<template>
  <div class="user-page">
    <div>
      <h1 class="text-2xl pb-4 text-red-400">Vista de Usuarios</h1>
    </div>
    <h1 v-if="loading" class="text-2xl text-red-400">...Cargando</h1>
    <appTable v-else :headers="headers">
      <template #body>
        <userCard
          v-for="user in userList"
          :key="user.id"
          :user="user"
          @edit="showDialog(user)"
        ></userCard>
      </template>
    </appTable>
    <appBtn
      class="bg-red-700 user-page__add-btn"
      fab
      fixed
      @click="showDialog()"
    >
      <iconAdd />
    </appBtn>
    <appDialog v-model="dialog">
      <template #text>
        <userForm
          :user.sync="model"
          :error-messages.sync="errorMessages"
          :creating="creating"
        />
      </template>
      <template #actions>
        <appBtn :loading="loading || sendingUserData" primary @click="saveInfo">
          Guardar
        </appBtn>
        <appBtn :disabled="loading || sendingUserData" @click="dialog = false">
          Cancelar
        </appBtn>
      </template>
    </appDialog>
  </div>
</template>

<script>
import constants from '../constants';
import userCard from '../components/user/card';
import iconAdd from '../components/icons/add';
import userForm from '../components/user/form';
import apiMixin from '../mixins/api';
import formMixin from '../mixins/form';
import { mapActions } from 'vuex';
export default {
  components: { userCard, iconAdd, userForm },
  mixins: [apiMixin, formMixin],
  data: () => ({
    headers: constants.UserHeaderTable,
    loading: false,
    dialog: false,
    errorMessages: {},
    sendingUserData: false,
    creating: true,
    model: { ...constants.userModel },
    loadingContracts: false,
  }),
  async mounted() {
    this.init();
  },
  methods: {
    ...mapActions({
      createUserAction: 'user/CREATE_USER',
      updateUserAction: 'user/UPDATE_USER',
    }),
    async saveInfo() {
      if (this.validateForm()) {
        this.sendingUserData = true;
        try {
          if (this.creating) {
            await this.createUserAction(this.model);
          } else {
            await this.updateUserAction(this.model);
          }
          this.dialog = false;
        } catch (e) {
          this.errorMessages = e;
        }
        this.sendingUserData = false;
      }
    },
    validateForm() {
      let id = this.rules.required(this.model.id);
      let emailHasText = this.rules.required(this.model.email);
      let emailValid = this.rules.required(this.model.email);
      let firstName = this.rules.required(this.model.firstName);
      let lastName = this.rules.required(this.model.lastName);
      let dateOfBirthHasText = this.rules.required(this.model.dateOfBirth);
      let dateOfBirthValid = this.rules.required(this.model.dateOfBirth);
      let employeeId = this.rules.required(this.model.employeeId);
      let contract = this.rules.required(this.model.contract);
      const valid =
        id === true &&
        emailHasText === true &&
        emailValid === true &&
        firstName === true &&
        lastName === true;

      if (valid) {
        return true;
      }

      id = id === true ? {} : { id };
      firstName = firstName === true ? {} : { firstName };
      lastName = lastName === true ? {} : { lastName };
      employeeId = employeeId === true ? {} : { employeeId };
      contract = contract === true ? {} : { contract };

      let email = {};
      if (emailHasText !== true) {
        email = { email: emailHasText };
      } else if (emailValid !== true) {
        email = { email: emailValid };
      }

      let dateOfBirth = {};
      if (dateOfBirthHasText !== true) {
        dateOfBirth = { dateOfBirth: dateOfBirthHasText };
      } else if (emailValid !== true) {
        dateOfBirth = { dateOfBirth: dateOfBirthValid };
      }

      this.errorMessages = {
        ...id,
        ...email,
        ...firstName,
        ...lastName,
        ...dateOfBirth,
        ...employeeId,
        ...contract,
      };
      return false;
    },
    showDialog(item) {
      this.creating = !item;
      if (item) {
        this.model = { ...item };
      } else {
        this.model = { ...constants.userModel };
      }
      this.dialog = true;
    },
    async init() {
      this.loading = true;
      if (this.userList.length === 0) {
        await this.fetchUserListAction();
      }
      if (this.contractList.length === 0) {
        await this.fetchContractListAction();
      }
      if (this.locationList.length === 0) {
        await this.fetchLocationListAction();
      }
      if (this.positionList.length === 0) {
        await this.fetchPositionListAction();
      }
      this.loading = false;
    },
  },
};
</script>
<style lang="css">
.user-page .user-page__add-btn {
  bottom: 12px;
  right: 12px;
}
</style>
